<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="de">
<head>
<!-- Generated by javadoc -->
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<title>ReadWriteSynchronizer (Apache Commons Configuration 2.2 API)</title>
<link rel="stylesheet" type="text/css" href="../../../../../stylesheet.css" title="Style">
<script type="text/javascript" src="../../../../../script.js"></script>
</head>
<body>
<script type="text/javascript"><!--
    try {
        if (location.href.indexOf('is-external=true') == -1) {
            parent.document.title="ReadWriteSynchronizer (Apache Commons Configuration 2.2 API)";
        }
    }
    catch(err) {
    }
//-->
var methods = {"i0":10,"i1":10,"i2":10,"i3":10};
var tabs = {65535:["t0","All Methods"],2:["t2","Instance Methods"],8:["t4","Concrete Methods"]};
var altColor = "altColor";
var rowColor = "rowColor";
var tableTab = "tableTab";
var activeTableTab = "activeTableTab";
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar.top">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.top.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/ReadWriteSynchronizer.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../../index-all.html">Index</a></li>
<li><a href="../../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../../../org/apache/commons/configuration2/sync/NoOpSynchronizer.html" title="enum in org.apache.commons.configuration2.sync"><span class="typeNameLink">Prev&nbsp;Class</span></a></li>
<li><a href="../../../../../org/apache/commons/configuration2/sync/Synchronizer.html" title="interface in org.apache.commons.configuration2.sync"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../../../index.html?org/apache/commons/configuration2/sync/ReadWriteSynchronizer.html" target="_top">Frames</a></li>
<li><a href="ReadWriteSynchronizer.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
<div class="subTitle">org.apache.commons.configuration2.sync</div>
<h2 title="Class ReadWriteSynchronizer" class="title">Class ReadWriteSynchronizer</h2>
</div>
<div class="contentContainer">
<ul class="inheritance">
<li><a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">java.lang.Object</a></li>
<li>
<ul class="inheritance">
<li>org.apache.commons.configuration2.sync.ReadWriteSynchronizer</li>
</ul>
</li>
</ul>
<div class="description">
<ul class="blockList">
<li class="blockList">
<dl>
<dt>All Implemented Interfaces:</dt>
<dd><a href="../../../../../org/apache/commons/configuration2/sync/Synchronizer.html" title="interface in org.apache.commons.configuration2.sync">Synchronizer</a></dd>
</dl>
<hr>
<br>
<pre>public class <span class="typeNameLabel">ReadWriteSynchronizer</span>
extends <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a>
implements <a href="../../../../../org/apache/commons/configuration2/sync/Synchronizer.html" title="interface in org.apache.commons.configuration2.sync">Synchronizer</a></pre>
<div class="block"><p>
 A special implementation of <code>Synchronizer</code> based on the JDK's
 <code>ReentrantReadWriteLock</code> class.
 </p>
 <p>
 This class manages a <code>ReadWriteLock</code> object internally. The methods of
 the <code>Synchronizer</code> interface are delegated to this lock. So this class
 behaves in the same way as documented for <code>ReentrantReadWriteLock</code>.
 </p>
 <p>
 Using this <code>Synchronizer</code> implementation is appropriate to make
 configuration objects thread-safe. This means that multiple threads can read
 configuration data in parallel; if one thread wants to update the
 configuration, this happens with an exclusive lock.
 </p></div>
<dl>
<dt><span class="simpleTagLabel">Since:</span></dt>
<dd>2.0</dd>
<dt><span class="simpleTagLabel">Version:</span></dt>
<dd>$Id: ReadWriteSynchronizer.java 1624601 2014-09-12 18:04:36Z oheger $</dd>
</dl>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- ======== CONSTRUCTOR SUMMARY ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor.summary">
<!--   -->
</a>
<h3>Constructor Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Constructor Summary table, listing constructors, and an explanation">
<caption><span>Constructors</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colOne" scope="col">Constructor and Description</th>
</tr>
<tr class="altColor">
<td class="colOne"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/sync/ReadWriteSynchronizer.html#ReadWriteSynchronizer--">ReadWriteSynchronizer</a></span>()</code>
<div class="block">Creates a new instance of <code>ReadWriteSynchronizer</code> and initializes
 it with a lock object of type <code>ReentrantReadWriteLock</code>.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colOne"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/sync/ReadWriteSynchronizer.html#ReadWriteSynchronizer-java.util.concurrent.locks.ReadWriteLock-">ReadWriteSynchronizer</a></span>(<a href="http://docs.oracle.com/javase/7/docs/api/java/util/concurrent/locks/ReadWriteLock.html?is-external=true" title="class or interface in java.util.concurrent.locks">ReadWriteLock</a>&nbsp;l)</code>
<div class="block">Creates a new instance of <code>ReadWriteSynchronizer</code> and initializes
 it with the given lock object.</div>
</td>
</tr>
</table>
</li>
</ul>
<!-- ========== METHOD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="method.summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Method Summary table, listing methods, and an explanation">
<caption><span id="t0" class="activeTableTab"><span>All Methods</span><span class="tabEnd">&nbsp;</span></span><span id="t2" class="tableTab"><span><a href="javascript:show(2);">Instance Methods</a></span><span class="tabEnd">&nbsp;</span></span><span id="t4" class="tableTab"><span><a href="javascript:show(8);">Concrete Methods</a></span><span class="tabEnd">&nbsp;</span></span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Method and Description</th>
</tr>
<tr id="i0" class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/sync/ReadWriteSynchronizer.html#beginRead--">beginRead</a></span>()</code>
<div class="block">Notifies this <code>Synchronizer</code> that the current thread is going to
 start a read operation on the managed configuration.</div>
</td>
</tr>
<tr id="i1" class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/sync/ReadWriteSynchronizer.html#beginWrite--">beginWrite</a></span>()</code>
<div class="block">Notifies this <code>Synchronizer</code> that the current thread is going to
 start a write operation on the managed configuration.</div>
</td>
</tr>
<tr id="i2" class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/sync/ReadWriteSynchronizer.html#endRead--">endRead</a></span>()</code>
<div class="block">Notifies this <code>Synchronizer</code> that the current thread has finished
 its read operation.</div>
</td>
</tr>
<tr id="i3" class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/sync/ReadWriteSynchronizer.html#endWrite--">endWrite</a></span>()</code>
<div class="block">Notifies this <code>Synchronizer</code> that the current thread has finished
 its write operation.</div>
</td>
</tr>
</table>
<ul class="blockList">
<li class="blockList"><a name="methods.inherited.from.class.java.lang.Object">
<!--   -->
</a>
<h3>Methods inherited from class&nbsp;java.lang.<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a></h3>
<code><a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#clone--" title="class or interface in java.lang">clone</a>, <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#equals-java.lang.Object-" title="class or interface in java.lang">equals</a>, <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#finalize--" title="class or interface in java.lang">finalize</a>, <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#getClass--" title="class or interface in java.lang">getClass</a>, <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#hashCode--" title="class or interface in java.lang">hashCode</a>, <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#notify--" title="class or interface in java.lang">notify</a>, <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#notifyAll--" title="class or interface in java.lang">notifyAll</a>, <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#toString--" title="class or interface in java.lang">toString</a>, <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#wait--" title="class or interface in java.lang">wait</a>, <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#wait-long-" title="class or interface in java.lang">wait</a>, <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#wait-long-int-" title="class or interface in java.lang">wait</a></code></li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ========= CONSTRUCTOR DETAIL ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor.detail">
<!--   -->
</a>
<h3>Constructor Detail</h3>
<a name="ReadWriteSynchronizer-java.util.concurrent.locks.ReadWriteLock-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>ReadWriteSynchronizer</h4>
<pre>public&nbsp;ReadWriteSynchronizer(<a href="http://docs.oracle.com/javase/7/docs/api/java/util/concurrent/locks/ReadWriteLock.html?is-external=true" title="class or interface in java.util.concurrent.locks">ReadWriteLock</a>&nbsp;l)</pre>
<div class="block">Creates a new instance of <code>ReadWriteSynchronizer</code> and initializes
 it with the given lock object. This constructor can be used to pass a
 lock object which has been configured externally. If the lock object is
 <b>null</b>, a default lock object is created.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>l</code> - the lock object to be used (can be <b>null</b>)</dd>
</dl>
</li>
</ul>
<a name="ReadWriteSynchronizer--">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>ReadWriteSynchronizer</h4>
<pre>public&nbsp;ReadWriteSynchronizer()</pre>
<div class="block">Creates a new instance of <code>ReadWriteSynchronizer</code> and initializes
 it with a lock object of type <code>ReentrantReadWriteLock</code>.</div>
</li>
</ul>
</li>
</ul>
<!-- ============ METHOD DETAIL ========== -->
<ul class="blockList">
<li class="blockList"><a name="method.detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a name="beginRead--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>beginRead</h4>
<pre>public&nbsp;void&nbsp;beginRead()</pre>
<div class="block"><span class="descfrmTypeLabel">Description copied from interface:&nbsp;<code><a href="../../../../../org/apache/commons/configuration2/sync/Synchronizer.html#beginRead--">Synchronizer</a></code></span></div>
<div class="block">Notifies this <code>Synchronizer</code> that the current thread is going to
 start a read operation on the managed configuration. This call can block
 if a concrete implementation decides that the thread has to wait until a
 specific condition is fulfilled.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../../../../../org/apache/commons/configuration2/sync/Synchronizer.html#beginRead--">beginRead</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../../org/apache/commons/configuration2/sync/Synchronizer.html" title="interface in org.apache.commons.configuration2.sync">Synchronizer</a></code></dd>
</dl>
</li>
</ul>
<a name="endRead--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>endRead</h4>
<pre>public&nbsp;void&nbsp;endRead()</pre>
<div class="block"><span class="descfrmTypeLabel">Description copied from interface:&nbsp;<code><a href="../../../../../org/apache/commons/configuration2/sync/Synchronizer.html#endRead--">Synchronizer</a></code></span></div>
<div class="block">Notifies this <code>Synchronizer</code> that the current thread has finished
 its read operation. This may cause other waiting threads to be granted
 access to the managed configuration.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../../../../../org/apache/commons/configuration2/sync/Synchronizer.html#endRead--">endRead</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../../org/apache/commons/configuration2/sync/Synchronizer.html" title="interface in org.apache.commons.configuration2.sync">Synchronizer</a></code></dd>
</dl>
</li>
</ul>
<a name="beginWrite--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>beginWrite</h4>
<pre>public&nbsp;void&nbsp;beginWrite()</pre>
<div class="block"><span class="descfrmTypeLabel">Description copied from interface:&nbsp;<code><a href="../../../../../org/apache/commons/configuration2/sync/Synchronizer.html#beginWrite--">Synchronizer</a></code></span></div>
<div class="block">Notifies this <code>Synchronizer</code> that the current thread is going to
 start a write operation on the managed configuration. This call may
 block. For instance, a concrete implementation may suspend the thread
 until all read operations currently active are finished,</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../../../../../org/apache/commons/configuration2/sync/Synchronizer.html#beginWrite--">beginWrite</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../../org/apache/commons/configuration2/sync/Synchronizer.html" title="interface in org.apache.commons.configuration2.sync">Synchronizer</a></code></dd>
</dl>
</li>
</ul>
<a name="endWrite--">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>endWrite</h4>
<pre>public&nbsp;void&nbsp;endWrite()</pre>
<div class="block"><span class="descfrmTypeLabel">Description copied from interface:&nbsp;<code><a href="../../../../../org/apache/commons/configuration2/sync/Synchronizer.html#endWrite--">Synchronizer</a></code></span></div>
<div class="block">Notifies this <code>Synchronizer</code> that the current thread has finished
 its write operation. This may cause other waiting threads to be granted
 access to the managed configuration.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../../../../../org/apache/commons/configuration2/sync/Synchronizer.html#endWrite--">endWrite</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../../org/apache/commons/configuration2/sync/Synchronizer.html" title="interface in org.apache.commons.configuration2.sync">Synchronizer</a></code></dd>
</dl>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar.bottom">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.bottom.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/ReadWriteSynchronizer.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../../index-all.html">Index</a></li>
<li><a href="../../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../../../org/apache/commons/configuration2/sync/NoOpSynchronizer.html" title="enum in org.apache.commons.configuration2.sync"><span class="typeNameLink">Prev&nbsp;Class</span></a></li>
<li><a href="../../../../../org/apache/commons/configuration2/sync/Synchronizer.html" title="interface in org.apache.commons.configuration2.sync"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../../../index.html?org/apache/commons/configuration2/sync/ReadWriteSynchronizer.html" target="_top">Frames</a></li>
<li><a href="ReadWriteSynchronizer.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
<p class="legalCopy"><small>Copyright &#169; 2001&#x2013;2017 <a href="https://www.apache.org/">The Apache Software Foundation</a>. All rights reserved.</small></p>
</body>
</html>
